diff -r 5e0d53cac617 trytond/modules/purchase/purchase.py
--- a/trytond/modules/purchase/purchase.py	Mon Sep 10 15:28:28 2012 +0200
+++ b/trytond/modules/purchase/purchase.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1514,53 +1290,47 @@
                 for product in template.products:
                     if not product.product_suppliers:
                         continue
-                    self.raise_user_warning(
+                    cls.raise_user_warning(
                             '%s@product_template' % template.id,
                             'change_purchase_uom')
+        super(Template, cls).write(templates, vals)
 
-        return super(Template, self).write(ids, vals)
 
-Template()
+class Product:
+    __name__ = 'product.product'
 
-
-class Product(ModelSQL, ModelView):
-    _name = 'product.product'
-
-    def get_purchase_price(self, ids, quantity=0):
+    @classmethod
+    def get_purchase_price(cls, products, quantity=0):
         '''
         Return purchase price for product ids.
         The context that can have as keys:
             uom: the unit of measure
             supplier: the supplier party id
             currency: the currency id for the returned price
-
-        :param ids: the product ids
-        :param quantity: the quantity of products
-        :return: a dictionary with for each product ids keys the computed price
         '''
         pool = Pool()
-        uom_obj = pool.get('product.uom')
-        user_obj = pool.get('res.user')
-        currency_obj = pool.get('currency.currency')
-        date_obj = pool.get('ir.date')
+        Uom = pool.get('product.uom')
+        User = pool.get('res.user')
+        Currency = pool.get('currency.currency')
+        Date = pool.get('ir.date')
 
-        today = date_obj.today()
+        today = Date.today()
         res = {}
 
         uom = None
         if Transaction().context.get('uom'):
-            uom = uom_obj.browse(Transaction().context['uom'])
+            uom = Uom(Transaction().context['uom'])
 
         currency = None
         if Transaction().context.get('currency'):
-            currency = currency_obj.browse(Transaction().context['currency'])
+            currency = Currency(Transaction().context['currency'])
 
-        user = user_obj.browse(Transaction().user)
+        user = User(Transaction().user)
 
-        for product in self.browse(ids):
+        for product in products:
             res[product.id] = product.cost_price
             default_uom = product.default_uom
-            default_currency = (user.company.currency.id if user.company
+            default_currency = (user.company.currency if user.company
                 else None)
             if not uom:
                 uom = default_uom
@@ -1570,29 +1340,25 @@
                 for product_supplier in product.product_suppliers:
                     if product_supplier.party.id == supplier_id:
                         for price in product_supplier.prices:
-                            if uom_obj.compute_qty(product.purchase_uom,
+                            if Uom.compute_qty(product.purchase_uom,
                                     price.quantity, uom) <= quantity:
                                 res[product.id] = price.unit_price
                                 default_uom = product.purchase_uom
-                                default_currency = product_supplier.currency.id
+                                default_currency = product_supplier.currency
                         break
-            res[product.id] = uom_obj.compute_price(default_uom,
-                    res[product.id], uom)
+            res[product.id] = Uom.compute_price(default_uom, res[product.id],
+                uom)
             if currency and default_currency:
                 date = Transaction().context.get('purchase_date') or today
                 with Transaction().set_context(date=date):
-                    res[product.id] = currency_obj.compute(default_currency,
-                        res[product.id], currency.id, round=False)
+                    res[product.id] = Currency.compute(default_currency,
+                        res[product.id], currency, round=False)
         return res
 
-Product()
-
 
 class ProductSupplier(ModelSQL, ModelView):
     'Product Supplier'
-    _name = 'purchase.product_supplier'
-    _description = __doc__
-
+    __name__ = 'purchase.product_supplier'
     product = fields.Many2One('product.template', 'Product', required=True,
             ondelete='CASCADE', select=True)
     party = fields.Many2One('party.party', 'Supplier', required=True,
@@ -1615,188 +1381,173 @@
     currency = fields.Many2One('currency.currency', 'Currency', required=True,
         ondelete='RESTRICT')
 
-    def __init__(self):
-        super(ProductSupplier, self).__init__()
-        self._order.insert(0, ('sequence', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(ProductSupplier, cls).__setup__()
+        cls._order.insert(0, ('sequence', 'ASC'))
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
         # Migration from 2.2 new field currency
         created_currency = table.column_exist('currency')
 
-        super(ProductSupplier, self).init(module_name)
+        super(ProductSupplier, cls).__register__(module_name)
 
         # Migration from 2.2 fill currency
         if not created_currency:
-            company_obj = Pool().get('company.company')
+            Company = Pool().get('company.company')
             limit = cursor.IN_MAX
-            cursor.execute('SELECT count(id) FROM "' + self._table + '"')
+            cursor.execute('SELECT count(id) FROM "' + cls._table + '"')
             product_supplier_count, = cursor.fetchone()
             for offset in range(0, product_supplier_count, limit):
                 cursor.execute(cursor.limit_clause(
                         'SELECT p.id, c.currency '
-                        'FROM "' + self._table + '" AS p '
-                        'INNER JOIN "' + company_obj._table + '" AS c '
+                        'FROM "' + cls._table + '" AS p '
+                        'INNER JOIN "' + Company._table + '" AS c '
                             'ON p.company = c.id '
                         'ORDER BY p.id',
                         limit, offset))
                 for product_supplier_id, currency_id in cursor.fetchall():
-                    cursor.execute('UPDATE "' + self._table + '" '
+                    cursor.execute('UPDATE "' + cls._table + '" '
                         'SET currency = %s '
                         'WHERE id = %s', (currency_id, product_supplier_id))
 
         # Migration from 2.4: drop required on sequence
         table.not_null_action('sequence', action='remove')
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def default_currency(self):
-        company_obj = Pool().get('company.company')
-        company = None
+    @staticmethod
+    def default_currency():
+        Company = Pool().get('company.company')
         if Transaction().context.get('company'):
-            company = company_obj.browse(Transaction().context['company'])
+            company = Company(Transaction().context['company'])
             return company.currency.id
 
-    def on_change_party(self, values):
+    def on_change_party(self):
         cursor = Transaction().cursor
         changes = {
             'currency': self.default_currency(),
             }
-        if values.get('party'):
+        if self.party:
             cursor.execute('SELECT currency FROM "' + self._table + '" '
                 'WHERE party = %s '
                 'GROUP BY currency '
-                'ORDER BY COUNT(1) DESC', (values['party'],))
+                'ORDER BY COUNT(1) DESC', (self.party.id,))
             row = cursor.fetchone()
             if row:
                 changes['currency'], = row
         return changes
 
-    def compute_supply_date(self, product_supplier, date=None):
+    def compute_supply_date(self, date=None):
         '''
         Compute the supply date for the Product Supplier at the given date
             and the next supply date
-
-        :param product_supplier: a BrowseRecord of the Product Supplier
-        :param date: the date of the purchase if None the current date
-        :return: the supply date
         '''
-        date_obj = Pool().get('ir.date')
+        Date = Pool().get('ir.date')
 
         if not date:
-            date = date_obj.today()
-        if not product_supplier.delivery_time:
+            date = Date.today()
+        if not self.delivery_time:
             return datetime.date.max
-        return date + datetime.timedelta(product_supplier.delivery_time)
+        return date + datetime.timedelta(self.delivery_time)
 
-    def compute_purchase_date(self, product_supplier, date):
+    def compute_purchase_date(self, date):
         '''
         Compute the purchase date for the Product Supplier at the given date
+        '''
+        Date = Pool().get('ir.date')
 
-        :param product_supplier: a BrowseRecord of the Product Supplier
-        :param date: the date of the supply
-        :return: the purchase date
-        '''
-        date_obj = Pool().get('ir.date')
-
-        if not product_supplier.delivery_time:
-            return date_obj.today()
-        return date - datetime.timedelta(product_supplier.delivery_time)
-
-ProductSupplier()
+        if not self.delivery_time:
+            return Date.today()
+        return date - datetime.timedelta(self.delivery_time)
 
 
 class ProductSupplierPrice(ModelSQL, ModelView):
     'Product Supplier Price'
-    _name = 'purchase.product_supplier.price'
-    _description = __doc__
-
+    __name__ = 'purchase.product_supplier.price'
     product_supplier = fields.Many2One('purchase.product_supplier',
             'Supplier', required=True, ondelete='CASCADE')
     quantity = fields.Float('Quantity', required=True, help='Minimal quantity')
     unit_price = fields.Numeric('Unit Price', required=True, digits=(16, 4))
 
-    def __init__(self):
-        super(ProductSupplierPrice, self).__init__()
-        self._order.insert(0, ('quantity', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(ProductSupplierPrice, cls).__setup__()
+        cls._order.insert(0, ('quantity', 'ASC'))
 
-    def default_quantity(self):
+    @staticmethod
+    def default_quantity():
         return 0.0
 
-ProductSupplierPrice()
 
+class ShipmentIn:
+    __name__ = 'stock.shipment.in'
 
-class ShipmentIn(ModelSQL, ModelView):
-    _name = 'stock.shipment.in'
-
-    def __init__(self):
-        super(ShipmentIn, self).__init__()
-        self.incoming_moves = copy.copy(self.incoming_moves)
+    @classmethod
+    def __setup__(cls):
+        super(ShipmentIn, cls).__setup__()
         add_remove = [
             ('supplier', '=', Eval('supplier')),
-        ]
-        if not self.incoming_moves.add_remove:
-            self.incoming_moves.add_remove = add_remove
+            ]
+        if not cls.incoming_moves.add_remove:
+            cls.incoming_moves.add_remove = add_remove
         else:
-            self.incoming_moves.add_remove = \
-                    copy.copy(self.incoming_moves.add_remove)
-            self.incoming_moves.add_remove = [
+            cls.incoming_moves.add_remove = [
                 add_remove,
-                self.incoming_moves.add_remove,
-            ]
-        self._reset_columns()
+                cls.incoming_moves.add_remove,
+                ]
 
-        self._error_messages.update({
+        cls._error_messages.update({
                 'reset_move': 'You cannot reset to draft a move generated '\
                     'by a purchase.',
             })
 
-    def write(self, ids, vals):
-        purchase_obj = Pool().get('purchase.purchase')
-        purchase_line_obj = Pool().get('purchase.line')
+    @classmethod
+    def write(cls, shipments, vals):
+        pool = Pool()
+        Purchase = pool.get('purchase.purchase')
+        PurchaseLine = pool.get('purchase.line')
 
-        res = super(ShipmentIn, self).write(ids, vals)
+        super(ShipmentIn, cls).write(shipments, vals)
 
         if 'state' in vals and vals['state'] in ('received', 'cancel'):
-            purchase_ids = []
+            purchases = []
             move_ids = []
-            if isinstance(ids, (int, long)):
-                ids = [ids]
-            for shipment in self.browse(ids):
+            for shipment in shipments:
                 move_ids.extend([x.id for x in shipment.incoming_moves])
 
-            purchase_line_ids = purchase_line_obj.search([
-                ('moves', 'in', move_ids),
-                ])
-            if purchase_line_ids:
-                for purchase_line in purchase_line_obj.browse(
-                        purchase_line_ids):
-                    if purchase_line.purchase.id not in purchase_ids:
-                        purchase_ids.append(purchase_line.purchase.id)
+            purchase_lines = PurchaseLine.search([
+                    ('moves', 'in', move_ids),
+                    ])
+            if purchase_lines:
+                for purchase_line in purchase_lines:
+                    if purchase_line.purchase not in purchases:
+                        purchases.append(purchase_line.purchase)
 
             with Transaction().set_user(0, set_context=True):
-                purchase_obj.process(purchase_ids)
-        return res
+                purchases = Purchase.browse([p.id for p in purchases])
+            Purchase.process(purchases)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('draft')
-    def draft(self, ids):
-        for shipment in self.browse(ids):
+    def draft(cls, shipments):
+        for shipment in shipments:
             for move in shipment.incoming_moves:
                 if move.state == 'cancel' and move.purchase_line:
-                    self.raise_user_error('reset_move')
+                    cls.raise_user_error('reset_move')
 
-        return super(ShipmentIn, self).draft(ids)
-
-ShipmentIn()
+        return super(ShipmentIn, cls).draft(shipments)
 
 
 class Move(ModelSQL, ModelView):
-    _name = 'stock.move'
-
+    __name__ = 'stock.move'
     purchase_line = fields.Many2One('purchase.line', 'Purchase Line',
         select=True, states={
             'readonly': Eval('state') != 'draft',
@@ -1829,7 +1580,7 @@
                 'invisible': ~Eval('purchase_visible', False),
                 }, depends=['purchase_visible']), 'get_purchase_fields')
     purchase_visible = fields.Function(fields.Boolean('Purchase Visible',
-        on_change_with=['from_location']), 'get_purchase_visible')
+        on_change_with=['from_location']), 'on_change_with_purchase_visible')
     supplier = fields.Function(fields.Many2One('party.party', 'Supplier',
         select=True), 'get_supplier', searcher='search_supplier')
     purchase_exception_state = fields.Function(fields.Selection([
@@ -1838,203 +1589,102 @@
         ('recreated', 'Recreated'),
         ], 'Exception State'), 'get_purchase_exception_state')
 
-    def get_purchase(self, ids, name):
-        res = {}
-        for move in self.browse(ids):
-            res[move.id] = None
-            if move.purchase_line:
-                res[move.id] = move.purchase_line.purchase.id
-        return res
+    def get_purchase(self, name):
+        if self.purchase_line:
+            return self.purchase_line.purchase.id
 
-    def get_purchase_exception_state(self, ids, name):
-        res = {}.fromkeys(ids, '')
-        for move in self.browse(ids):
-            if not move.purchase_line:
-                continue
-            if move.id in (x.id for x in move.purchase_line.moves_recreated):
-                res[move.id] = 'recreated'
-            if move.id in (x.id for x in move.purchase_line.moves_ignored):
-                res[move.id] = 'ignored'
-        return res
+    def get_purchase_exception_state(self, name):
+        if not self.purchase_line:
+            return ''
+        if self in self.purchase_line.moves_recreated:
+            return 'recreated'
+        if self in self.purchase_line.moves_ignored:
+            return 'ignored'
 
-    def search_purchase(self, name, clause):
+    @classmethod
+    def search_purchase(cls, name, clause):
         return [('purchase_line.' + name,) + tuple(clause[1:])]
 
-    def get_purchase_fields(self, ids, names):
-        res = {}
-        for name in names:
-            res[name] = {}
+    def get_purchase_fields(self, name):
+        if self.purchase_line:
+            if name[9:] == 'currency':
+                return self.purchase_line.purchase.currency.id
+            elif name[9:] in ('quantity', 'unit_digits', 'unit_price'):
+                return getattr(self.purchase_line, name[9:])
+            else:
+                return getattr(self.purchase_line, name[9:]).id
+        else:
+            if name[9:] == 'quantity':
+                return 0.0
+            elif name[9:] == 'unit_digits':
+                return 2
 
-        for move in self.browse(ids):
-            for name in res.keys():
-                if name[9:] == 'quantity':
-                    res[name][move.id] = 0.0
-                elif name[9:] == 'unit_digits':
-                    res[name][move.id] = 2
-                else:
-                    res[name][move.id] = None
-            if move.purchase_line:
-                for name in res.keys():
-                    if name[9:] == 'currency':
-                        res[name][move.id] = move.purchase_line.\
-                                purchase.currency.id
-                    elif name[9:] in ('quantity', 'unit_digits', 'unit_price'):
-                        res[name][move.id] = move.purchase_line[name[9:]]
-                    else:
-                        res[name][move.id] = move.purchase_line[name[9:]].id
-        return res
-
-    def on_change_with_purchase_visible(self, vals):
-        location_obj = Pool().get('stock.location')
-        if vals.get('from_location'):
-            from_location = location_obj.browse(vals['from_location'])
-            if from_location.type == 'supplier':
+    def on_change_with_purchase_visible(self, name=None):
+        if self.from_location:
+            if self.from_location.type == 'supplier':
                 return True
         return False
 
-    def get_purchase_visible(self, ids, name):
-        res = {}
-        for move in self.browse(ids):
-            res[move.id] = False
-            if move.from_location.type == 'supplier':
-                res[move.id] = True
-        return res
+    def get_supplier(self, name):
+        if self.purchase_line:
+            return self.purchase_line.purchase.party.id
 
-    def get_supplier(self, ids, name):
-        res = {}
-        for move in self.browse(ids):
-            res[move.id] = None
-            if move.purchase_line:
-                res[move.id] = move.purchase_line.purchase.party.id
-        return res
-
-    def search_supplier(self, name, clause):
+    @classmethod
+    def search_supplier(cls, name, clause):
         return [('purchase_line.purchase.party',) + tuple(clause[1:])]
 
-    def write(self, ids, vals):
-        purchase_obj = Pool().get('purchase.purchase')
-        purchase_line_obj = Pool().get('purchase.line')
+    @classmethod
+    def write(cls, moves, vals):
+        pool = Pool()
+        Purchase = pool.get('purchase.purchase')
+        PurchaseLine = pool.get('purchase.line')
 
-        res = super(Move, self).write(ids, vals)
+        super(Move, cls).write(moves, vals)
         if 'state' in vals and vals['state'] in ('cancel',):
-            if isinstance(ids, (int, long)):
-                ids = [ids]
-            purchase_ids = set()
-            purchase_line_ids = purchase_line_obj.search([
-                ('moves', 'in', ids),
+            purchases = set()
+            purchase_lines = PurchaseLine.search([
+                    ('moves', 'in', [m.id for m in moves]),
+                    ])
+            if purchase_lines:
+                for purchase_line in purchase_lines:
+                    purchases.add(purchase_line.purchase)
+            if purchases:
+                with Transaction().set_user(0, set_context=True):
+                    purchases = Purchase.browse([p.id for p in purchases])
+                Purchase.process(purchases)
+
+    @classmethod
+    def delete(cls, moves):
+        pool = Pool()
+        Purchase = pool.get('purchase.purchase')
+        PurchaseLine = pool.get('purchase.line')
+
+        purchases = set()
+        purchase_lines = PurchaseLine.search([
+                ('moves', 'in', [m.id for m in moves]),
                 ])
-            if purchase_line_ids:
-                for purchase_line in purchase_line_obj.browse(
-                        purchase_line_ids):
-                    purchase_ids.add(purchase_line.purchase.id)
-            if purchase_ids:
+
+        super(Move, cls).delete(moves)
+
+        if purchase_lines:
+            for purchase_line in purchase_lines:
+                purchases.add(purchase_line.purchase)
+            if purchases:
                 with Transaction().set_user(0, set_context=True):
-                    purchase_obj.process(list(purchase_ids))
-        return res
-
-    def delete(self, ids):
-        purchase_obj = Pool().get('purchase.purchase')
-        purchase_line_obj = Pool().get('purchase.line')
-
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-
-        purchase_ids = set()
-        purchase_line_ids = purchase_line_obj.search([
-            ('moves', 'in', ids),
-            ])
-
-        res = super(Move, self).delete(ids)
-
-        if purchase_line_ids:
-            for purchase_line in purchase_line_obj.browse(purchase_line_ids):
-                purchase_ids.add(purchase_line.purchase.id)
-            if purchase_ids:
-                with Transaction().set_user(0, set_context=True):
-                    purchase_obj.process(list(purchase_ids))
-        return res
-Move()
-
-
-class Invoice(ModelSQL, ModelView):
-    _name = 'account.invoice'
-
-    purchase_exception_state = fields.Function(fields.Selection([
-        ('', ''),
-        ('ignored', 'Ignored'),
-        ('recreated', 'Recreated'),
-        ], 'Exception State'), 'get_purchase_exception_state')
-
-    def __init__(self):
-        super(Invoice, self).__init__()
-        self._error_messages.update({
-                'delete_purchase_invoice': 'You can not delete invoices ' \
-                    'that come from a purchase!',
-                'reset_invoice_purchase': 'You cannot reset to draft ' \
-                        'an invoice generated by a purchase.',
-            })
-
-    @ModelView.button
-    @Workflow.transition('draft')
-    def draft(self, ids):
-        purchase_obj = Pool().get('purchase.purchase')
-        purchase_ids = purchase_obj.search([
-            ('invoices', 'in', ids),
-            ])
-
-        if purchase_ids:
-            self.raise_user_error('reset_invoice_purchase')
-
-        return super(Invoice, self).draft(ids)
-
-    def get_purchase_exception_state(self, ids, name):
-        purchase_obj = Pool().get('purchase.purchase')
-        purchase_ids = purchase_obj.search([
-            ('invoices', 'in', ids),
-            ])
-
-        purchases = purchase_obj.browse(purchase_ids)
-
-        recreated_ids = tuple(i.id for p in purchases
-            for i in p.invoices_recreated)
-        ignored_ids = tuple(i.id for p in purchases
-            for i in p.invoices_ignored)
-
-        res = {}.fromkeys(ids, '')
-        for invoice in self.browse(ids):
-            if invoice.id in recreated_ids:
-                res[invoice.id] = 'recreated'
-            elif invoice.id in ignored_ids:
-                res[invoice.id] = 'ignored'
-
-        return res
-
-    def delete(self, ids):
-        cursor = Transaction().cursor
-        if not ids:
-            return True
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        cursor.execute('SELECT id FROM purchase_invoices_rel ' \
-                'WHERE invoice IN (' + ','.join(('%s',) * len(ids)) + ')',
-                ids)
-        if cursor.fetchone():
-            self.raise_user_error('delete_purchase_invoice')
-        return super(Invoice, self).delete(ids)
-
-Invoice()
+                    purchases = Purchase.browse([p.id for p in purchases])
+                Purchase.process(purchases)
 
 
 class OpenSupplier(Wizard):
     'Open Suppliers'
-    _name = 'purchase.open_supplier'
+    __name__ = 'purchase.open_supplier'
     start_state = 'open_'
     open_ = StateAction('party.act_party_form')
 
-    def do_open_(self, session, action):
+    def do_open_(self, action):
         pool = Pool()
-        model_data_obj = pool.get('ir.model.data')
-        wizard_obj = pool.get('ir.action.wizard')
+        ModelData = pool.get('ir.model.data')
+        Wizard = pool.get('ir.action.wizard')
         cursor = Transaction().cursor
 
         cursor.execute("SELECT DISTINCT(party) FROM purchase_purchase")
@@ -2042,25 +1692,20 @@
         action['pyson_domain'] = PYSONEncoder().encode(
             [('id', 'in', supplier_ids)])
 
-        model_data_ids = model_data_obj.search([
-            ('fs_id', '=', 'act_open_supplier'),
-            ('module', '=', 'purchase'),
-            ('inherit', '=', None),
-            ], limit=1)
-        model_data = model_data_obj.browse(model_data_ids[0])
-        wizard = wizard_obj.browse(model_data.db_id)
+        model_data, = ModelData.search([
+                ('fs_id', '=', 'act_open_supplier'),
+                ('module', '=', 'purchase'),
+                ('inherit', '=', None),
+                ], limit=1)
+        wizard = Wizard.browse(model_data.db_id)
 
         action['name'] = wizard.name
         return action, {}
 
-OpenSupplier()
-
 
 class HandleShipmentExceptionAsk(ModelView):
     'Handle Shipment Exception'
-    _name = 'purchase.handle.shipment.exception.ask'
-    _description = __doc__
-
+    __name__ = 'purchase.handle.shipment.exception.ask'
     recreate_moves = fields.Many2Many(
         'stock.move', None, None, 'Recreate Moves',
         domain=[('id', 'in', Eval('domain_moves'))], depends=['domain_moves'],
@@ -2069,21 +1714,20 @@
     domain_moves = fields.Many2Many(
         'stock.move', None, None, 'Domain Moves')
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.2: packing renamed into shipment
         cursor.execute("UPDATE ir_model "\
                 "SET model = REPLACE(model, 'packing', 'shipment') "\
                 "WHERE model like '%%packing%%' AND module = %s",
                 (module_name,))
-        super(HandleShipmentExceptionAsk, self).init(module_name)
-
-HandleShipmentExceptionAsk()
+        super(HandleShipmentExceptionAsk, cls).__register__(module_name)
 
 
 class HandleShipmentException(Wizard):
     'Handle Shipment Exception'
-    _name = 'purchase.handle.shipment.exception'
+    __name__ = 'purchase.handle.shipment.exception'
     start_state = 'ask'
     ask = StateView('purchase.handle.shipment.exception.ask',
         'purchase.handle_shipment_exception_ask_view_form', [
@@ -2092,61 +1736,56 @@
             ])
     handle = StateTransition()
 
-    def default_ask(self, session, fields):
-        purchase_obj = Pool().get('purchase.purchase')
+    def default_ask(self, fields):
+        Purchase = Pool().get('purchase.purchase')
 
-        purchase = purchase_obj.browse(Transaction().context['active_id'])
+        purchase = Purchase(Transaction().context['active_id'])
 
         moves = []
         for line in purchase.lines:
-            skip_ids = set(x.id for x in line.moves_ignored + \
-                               line.moves_recreated)
+            skip = set(line.moves_ignored + line.moves_recreated)
             for move in line.moves:
-                if move.state == 'cancel' and move.id not in skip_ids:
+                if move.state == 'cancel' and move not in skip:
                     moves.append(move.id)
         return {
             'to_recreate': moves,
             'domain_moves': moves,
             }
 
-    def transition_handle(self, session):
+    def transition_handle(self):
         pool = Pool()
-        purchase_obj = pool.get('purchase.purchase')
-        purchase_line_obj = pool.get('purchase.line')
-        to_recreate = [x.id for x in session.ask.recreate_moves]
-        domain_moves = [x.id for x in session.ask.domain_moves]
+        Purchase = pool.get('purchase.purchase')
+        PurchaseLine = pool.get('purchase.line')
+        to_recreate = self.ask.recreate_moves
+        domain_moves = self.ask.domain_moves
 
-        purchase = purchase_obj.browse(Transaction().context['active_id'])
+        purchase = Purchase(Transaction().context['active_id'])
 
         for line in purchase.lines:
             moves_ignored = []
             moves_recreated = []
-            skip_ids = set(x.id for x in line.moves_ignored)
-            skip_ids.update(x.id for x in line.moves_recreated)
+            skip = set(line.moves_ignored)
+            skip.update(line.moves_recreated)
             for move in line.moves:
-                if move.id not in domain_moves or move.id in skip_ids:
+                if move not in domain_moves or move in skip:
                     continue
-                if move.id in to_recreate:
+                if move in to_recreate:
                     moves_recreated.append(move.id)
                 else:
                     moves_ignored.append(move.id)
 
-            purchase_line_obj.write(line.id, {
+            PurchaseLine.write([line], {
                 'moves_ignored': [('add', moves_ignored)],
                 'moves_recreated': [('add', moves_recreated)],
                 })
 
-        purchase_obj.process([purchase.id])
+        Purchase.process([purchase])
         return 'end'
 
-HandleShipmentException()
-
 
 class HandleInvoiceExceptionAsk(ModelView):
     'Handle Invoice Exception'
-    _name = 'purchase.handle.invoice.exception.ask'
-    _description = __doc__
-
+    __name__ = 'purchase.handle.invoice.exception.ask'
     recreate_invoices = fields.Many2Many(
         'account.invoice', None, None, 'Recreate Invoices',
         domain=[('id', 'in', Eval('domain_invoices'))],
@@ -2156,12 +1795,10 @@
     domain_invoices = fields.Many2Many(
         'account.invoice', None, None, 'Domain Invoices')
 
-HandleInvoiceExceptionAsk()
-
 
 class HandleInvoiceException(Wizard):
     'Handle Invoice Exception'
-    _name = 'purchase.handle.invoice.exception'
+    __name__ = 'purchase.handle.invoice.exception'
     start_state = 'ask'
     ask = StateView('purchase.handle.invoice.exception.ask',
         'purchase.handle_invoice_exception_ask_view_form', [
